import org.bytedeco.javacpp.caffe._

object ExampleGPU {
  def main(args: Array[String]) {
    val netParam = new NetParameter();
    ReadProtoFromTextFileOrDie("cifar10_quick.prototxt", netParam);
    val caffeNet = new FloatNet(netParam)
    val inputSize = netParam.input_size

    val inputs = new FloatBlobVector(inputSize)
    val inputRef = new Array[FloatBlob](inputSize)
    for (i <- 0 to inputSize - 1) {
      val dims = new Array[Int](netParam.input_shape(i).dim_size)
      for (j <- dims.indices) {
        dims(j) = netParam.input_shape(i).dim(j).toInt
      }
      inputRef(i) = new FloatBlob(dims)
      inputs.put(i, inputRef(i))
    }

    val t1 = System.currentTimeMillis()
    for (i <- 0 to 20) {
      Caffe.set_mode(Caffe.GPU) // this line makes no difference
      val tops = caffeNet.ForwardBackward(inputs)
    }
    val t2 = System.currentTimeMillis()
    print("iters took " + ((t2 - t1) * 1F / 1000F).toString + " s\n")
  }
}
